

#ifndef MAIN_HEADER  //Prevents multiple includes
	#define MAIN_HEADER

// JEtzt in MAIN H den Benutz aktivieren

//entweder oder

//***************************************
//#define AVATARBASE_FIRMWARE_USED
#define CHRISTOF_FIRMWARE_USED
//#define STEPHAN_FIRMWARE_USED
//***************************************

// Mit // abschalten was man grad nicht mehr braucht.

//***************************************
#define TICK_MSG_USED
#define UART_USE_ENABLED
//#define DEBUG_TX_TRAFFIC_USED
#define TX_SWITCH_EVENT_USED  // main fast fr anfangstest
#define TX_TRAFFIC_USED   // Textausgaben im TICKER
#define ADC_USED_ENABLED
//#define PWM_ON_D11_USED // in myasuro.h
//#define IR_DISTANCE_USED 
//***************************************

// Hardwareassignment
#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	2400	//ASURO
//#define UART_BAUD_RATE	19200	//ASURO

#define DISABLE_ALL_PULLUP()	(SFIOR |= _BV(PUD))
#define ENABLE_ALLUP_SCL()		(SFIOR &= ~(_BV(PUD)))

#ifdef ADC_USED_ENABLED
	#define ADC_BANDGAP_VOLTAGE	2.56  // zur verrechnung
	#define ADC_EXTERN_5V	0x00
	#define ADC_5V_AN_C		0x40 //(1<< REFS0)
	#define ADC_INTERN_BANDGAP_2_56V	0xC0 //((1<< REFS1) | (1<< REFS0))	
extern uint16_t ADC_AT8_10Bit(uint8_t u8Chan); // 0..7
#endif

//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3

//=============================
#define WDTO_2S   7 //WatchDog
//=============================



// 8000000 / 111 = 72072.07207
// 72000 / 256 = 281.5315315
//RUNDUNG

//1 MHZ / 256/ 256
#define TICK_10SEKUNDEN 2441
#define TICK_2000MS 488
#define TICK_1500MS 366
#define TICK_1000MS 244
#define TICK_500MS 122
#define TICK_250MS 61
#define TICK_100MS 24
#define TICK_50MS 12
#define TICK_25MS 6
#define TICK_10MS 2


//Erzeuge aus 7KHZ 50 Herz PWM
/*
#define PWM_1MS 72
// #define PWM_2MS	144 
#define PWM_LINKS 	170
#define PWM_MITTE	110 // 108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)
#define PWM_RECHTS	60
*/
#define PWM_1MS 50
#define PWM_2MS	150
//#define PWM_1MS 36
//#define PWM_2MS	176
//#define PWM_MITTE	108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)

#define PWM_LINKS 	160
#define PWM_MITTE	110 // 108  // ((PWM_2MS- PWM_1MS) + PWM_1MS)
#define PWM_RECHTS	60


// Flags zur Programmsteuerung
//#define STOP_UART_RX	0x01
//#define IR_40KHZ_OFF	0x02 // fr normal COM  ohne IR
#define SWITCH_EVENT_FLAG			0x01
#define SERVO_DIRECTION				0x02
#define AUTOMAT_STATEMACHINE 		0x80
//gu8ProgModeFlag

#define IR_TRAFFIC_ON		0x02
#define SW_TRAFFIC_ON		0x04
#define SW_EVENT_TRAFFIC_ON	0x08
#define DEBUG_TRAFFIC_ON	0x40
#define TX_ODO_EVENT_ON 	0x80
//gu8TxFlag


//#define IR_SENSOR_ADC	5  //das war an der  LED  D11
#define IR_SENSOR_ADC	3 // das ist am ehemaligen Transistor T9
//DIESEN WERT ANPASSEN ,das Tastenwerte kommen wie
// K1 = 32, K2 = 16, K3 = 8, K4 = 4, K5 = 2, K6 = 1
#define MY_SWITCH_VALUE 63
////62L, 63L, 64L oder 65

//#define ROUND_INT(d) ( (int) ((d) + ((d) > 0 ? 0.5 : -0.5)) )

//Gloable externe Variablen
extern volatile unsigned long  gu32_Ticks; //  T2 timeCounter
extern volatile unsigned long gu32BlinkTime;
extern volatile unsigned char gu8ProgModeFlag;
extern volatile unsigned char gu8TxFlag;

extern uint8_t Abweichung(int32_t i16Val1,int32_t i32Val2, uint16_t u16Difference);
//extern uint16_t ADC_Average(register uint8_t u8Chan); // 0..7
extern uint16_t GetIR_Sens(void);
extern unsigned char gu8PWM_D11_Val;  // Compare PWM

//extern volatile uint32_t gu32BlinkTime

#endif  //MAIN_HEADER
